clear all
close all
clc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% ENV index                                                          %%%%
%%%  Luca Martino, Eduardo Morgado, Roberto San Millán,                %%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
%%% JUST RUN ME !!
%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%
example=1;
disp('----------------------------------------------------------------------------')
%%%%%%%%%%%%%%%%%%%%
switch example
    
      case 1
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%% Artificial example
        %K_here=20;
        %K_here=50;
        K_here=500;
        %K_here=5000;
        components=0:1:K_here;
        V=exp(-0.1*components);
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       disp(['Artificial Example ',num2str(example),' with K =',num2str(K_here)])
     case 2
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Variable Selection regression Soundscape Data
       load VarSelection_regresion_SoundscapeData_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       disp('Variable Selection regression Soundscape Data - Experiment')
     case 3
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
       %%%% Variable Selection classification Biomedical Data
       load VarSelection_classification_BioData_experiment
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
       disp('Variable Selection classification Biomedical Data - Experiment 1')     
  
end
disp('----------------------------------------------------------------------------')
%%%%%%%%%%%%%%%%%
V=V-min(V); %%% just a check, without loss of generality
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
K=length(V)-1;
%%%%%%%%%%%%%%%%
%%%%%%% ENV %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I_ENV=1+2*sum(V(2:end))/V(1)
k_by_ENV=round(I_ENV)
CI_env=(V(1)-V(round(I_ENV)))/V(1)
R_env=min([1,k_by_ENV/I_ENV])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% UAED %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda=V(1)/K;
CostFun=V+lambda*[0:K];
pos=find(CostFun==min(CostFun));
Elbow_UAED=pos-1;
disp('------------------------------------------------------------------')
disp('------------------------------------------------------------------')
disp('whereas UAED (as the other elbow detectors) chooses:')
Elbow_UAED
 CI_uaed=(V(1)-V(Elbow_UAED))/V(1)
 R_uaed=min([1,Elbow_UAED/I_ENV])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plot(0:K,V,'LineWidth',2)
hold on
plot(Elbow_UAED,V(pos),'ro','MarkerSize',10,'MarkerFaceColor','g')
plot(k_by_ENV,V(k_by_ENV+1),'ro','MarkerSize',10,'MarkerFaceColor','r')
set(gca,'Fontsize',20)
xlabel('k')
ylabel('V(k)')
legend('V(k)','Elbow','ENV solution')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


